import Consumer from '../src/consumer'

const USOCKET = __dirname + '/sample.sock'


class Client extends Consumer {
  constructor(path,opts) {
    super(path,opts)
    this.packet._process = async function (packet) {
      console.log(`Packet from ${packet.name} Processed by Socket: ${packet.status}`)
    }
  }
}

const client1= new Client(USOCKET, {log:false,name:'example-consumer1' })
const client2 = new Client(USOCKET, {log:false,name:'example-consumer2'})

let packet1 = {name: 'client1', cmd:'doit', data:'data sent by client1'}
let packet2 = {name: 'client2', cmd:'doit', data:'data sent by client2'}

;
(async () => {

  await Promise.all([client1.connect(),client2.connect()])
  await Promise.all([client1.send(packet1),client2.send(packet2)])

})().catch(err => {
  console.error('FATAL: UNABLE TO START SYSTEM!\n',err)
})
